<?php

/**
 * acceso_acceso actions.
 *
 * @package    canon
 * @subpackage acceso_acceso
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class acceso_accesoActions extends sfQuery {

    /**
     * Metodo list de accesos
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejo de errores
         */
        try {

            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 300;
            }

            /*
             * variables de filtro
             */

            $whereModulo = ' ';
            if (isset($request['id_modulo'])) {
                $whereModulo = " AND tab1.id_modulo = '" . $request['id_modulo'] . "' ";
            }

            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from(
 
    select 
    tab1.id_acceso, tab0.id_acceso_padre, tab1.cod_func, tab1.es_funcion, tab1.rotulo, tab1.id_modulo, tab1.estado, tab0.orden 
    from ca_acceso_acceso tab0 
    join ca_acceso tab1 on tab0.id_acceso_hijo=tab1.id_acceso
    where 1=1  $whereModulo
            
    ORDER BY id_acceso_padre, orden        
 
)tabla
EOD;

            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];

            //validar si hay registros
            if ($total_record_count > 0) {

                /*
                 * Obtiene los accesos para un perfil
                 */
                $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (
      
    select 
    tab1.id_acceso, tab0.id_acceso_padre, tab1.cod_func, tab1.es_funcion, tab1.rotulo, tab1.id_modulo, tab1.estado, tab0.orden 
    from ca_acceso_acceso tab0 
    join ca_acceso tab1 on tab0.id_acceso_hijo=tab1.id_acceso
    where 1=1  $whereModulo
            
    ORDER BY id_acceso_padre, orden        
            
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;

                //ejecuta y obtiene el resultado del sql
                $records = CN_TABLE::executeSQL($sql);

                // Solo registra log la primera vez de consulta
                if ($rowStart == 0) {
                    //Operaciones: 1-CONSULTAR, 2-ACTUALIZAR, 3-ADICIONAR, 4-ELIMINAR, 5-ANULAR
                    $id_ope_bd = 1;
                    //obtener id maestro tabla
                    $id_mae_bd = CN_TABLE::consultarIdTablaBD('ca_acceso_acceso');
                    //registro de consulta en tabla de log- la observacion puede o no enviarse ($request, $id_ope_bd, $id_mae_bd, $observacion)
                  //  $sql = CN_TABLE::registrarLog($request, $id_ope_bd, $id_mae_bd);
                }

                $this->totalRows = $total_record_count;
                $this->startRow = $rowStart;
                $this->endRow = $rowEnd;
                $this->status = 0;
                $this->list_data = $records;
                $this->logMessage("[ACCESOS_ACCESOS] Consulta exitosa.");
            } else {

                $mensaje = "[ACCESOS_ACCESOS] No hay registros de consulta.";
                $this->status = 0;
                $this->list_data = array();
                $this->logMessage($mensaje);
            }
        } catch (Exception $e) {
            $error="[ACCESOS_ACCESOS] ERROR: ". $e->getMessage();
            $this->status = 1;
            $this->list_data = array();
            $this->mensajeError = $error;
            $this->logMessage($error);
        }
    }

    public function executeAdd(sfWebRequest $request) {
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejo de errores
         */
        try {

            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 75;
            }

            /*
             * variables de filtro
             */
            $whereModulo = ' ';
            if (isset($request['id_modulo'])) {
                $whereModulo = " AND tab1.id_modulo = '" . $request['id_modulo'] . "' ";
            }

            $accesoPadre = $request['id_acceso_padre'];

            $accesoHijo = $request['id_acceso_hijo'];

            $sql = <<<EOD
            
select 
     max(tab0.orden) as orden, count(tab0.orden) as registros
    from ca_acceso_acceso tab0 
    join ca_acceso tab1 on tab0.id_acceso_hijo=tab1.id_acceso
    where 1=1  and id_acceso_padre=$accesoPadre
            
    ORDER BY id_acceso_padre, orden        
            
EOD;

            //Insertar nuevos accesos
            $maxOrden = CN_TABLE::executeSQL($sql);


            if ($maxOrden[0]["registros"] == 0) {
                $orden = 0;
            } else {
                $orden = $maxOrden[0]["orden"] + 1;
            }


            $sql = <<<EOD
            
INSERT INTO ca_acceso_acceso (id_acceso_padre, id_acceso_hijo, orden) values ($accesoPadre, $accesoHijo, $orden)


EOD;

            //Insertar nuevos accesos
            CN_TABLE::executeSQL($sql);

            $this->logMessage("[ACCESOS_ACCESOS-ADD] Registro Exitoso");

            $sql = <<<EOD
select count(*) as count from(

 
    select 
    tab1.id_acceso, tab0.id_acceso_padre, tab1.cod_func, tab1.es_funcion, tab1.rotulo, tab1.id_modulo, tab1.estado, tab0.orden 
    from ca_acceso_acceso tab0 
    join ca_acceso tab1 on tab0.id_acceso_hijo=tab1.id_acceso
    where 1=1  $whereModulo
            
    ORDER BY id_acceso_padre, orden        
            
 
 
)tabla
EOD;

            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];

            //validar si hay registros
            if ($total_record_count > 0) {


                /*
                 * Obtiene los accesos para un perfil
                 */
                $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (
 
            
    select 
    tab1.id_acceso, tab0.id_acceso_padre, tab1.cod_func, tab1.es_funcion, tab1.rotulo, tab1.id_modulo, tab1.estado, tab0.orden 
    from ca_acceso_acceso tab0 
    join ca_acceso tab1 on tab0.id_acceso_hijo=tab1.id_acceso
    where 1=1  $whereModulo
            
    ORDER BY id_acceso_padre, orden        
            
 
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;


                //ejecuta y obtiene el resultado del sql
                $records = CN_TABLE::executeSQL($sql);

                // Solo regsitra log la primera vez de consulta
                if ($rowStart == 0) {
                    //Operaciones: 1-CONSULTAR, 2-ACTUALIZAR, 3-ADICIONAR, 4-ELIMINAR, 5-ANULAR
                    $id_ope_bd = 3;
                    //obtener id maestro tabla
                    $id_mae_bd = CN_TABLE::consultarIdTablaBD('ca_acceso_acceso');
                    //registro de consulta en tabla de log- la observacion puede o no enviarse ($request, $id_ope_bd, $id_mae_bd, $observacion)
                 //   $sql = CN_TABLE::registrarLog($request, $id_ope_bd, $id_mae_bd);
                }
             
                $this->totalRows = $total_record_count;
                $this->startRow = $rowStart;
                $this->endRow = $rowEnd;
                $this->status = 0;
                $this->list_data = $records;
                $this->logMessage("[ACCESOS_ACCESOS] Consulta exitosa.");
            } else {

                $mensaje = "[ACCESOS_ACCESOS] No hay registros de consulta.";
                $this->status = 1;
                $this->mensajeError = $mensaje;
                $this->list_data = array();
                $this->logMessage($mensaje);
            }
        } catch (Exception $e) {


            $this->logMessage("[ACCESOS_ACCESOS-ADD] Registro Fallido $e");
            $this->status = 1;
            $this->list_data = array();
        }
    }

    public function executeUpdate(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejo de errores
         */
        try {

            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 75;
            }

            /*
             * variables de filtro
             */

            $whereModulo = ' ';
            if (isset($request['id_modulo'])) {
                $whereModulo = " AND tab1.id_modulo = '" . $request['id_modulo'] . "' ";
            }

            $orden = "'" . $request['orden'] . "'";

            $whereAccesoPadre = " and id_acceso_padre = '" . $request['id_acceso_padre'] . "' ";

            $whereAccesoHijo = " and id_acceso_hijo = '" . $request['id_acceso'] . "' ";

          
            $sql = <<<EOD

   UPDATE ca_acceso_acceso SET orden=$orden where 1=1 $whereAccesoPadre $whereAccesoHijo
   
EOD;

            //ejecuta y obtiene el resultado del sql
            $records = CN_TABLE::executeSQL($sql);
            // Solo regsitra log la primera vez de consulta
            if ($rowStart == 0) {
                //Operaciones: 1-CONSULTAR, 2-ACTUALIZAR, 3-ADICIONAR, 4-ELIMINAR, 5-ANULAR
                $id_ope_bd = 2;
                //obtener id maestro tabla
                $id_mae_bd = CN_TABLE::consultarIdTablaBD('ca_acceso_acceso');
                //registro de consulta en tabla de log- la observacion puede o no enviarse ($request, $id_ope_bd, $id_mae_bd, $observacion)
             //   $sql = CN_TABLE::registrarLog($request, $id_ope_bd, $id_mae_bd);
            }

            $this->status = 0;
            $this->list_data = $records;
            $this->logMessage("[ACCESOS_ACCESOS] Consulta Update exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->mensajeError = "ERROR UPDATE!!!";
            $this->list_data = array();
            $this->logMessage("ERROR UPDATE!!!");
            $this->logMessage("Error: " . $e->getMessage());
        }
    }
    
    
    public function executeRemove(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejo de errores
         */
        try {

            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 75;
            }

            /*
             * variables de filtro
             */

            $whereModulo = ' ';
            if (isset($request['id_modulo'])) {
                $whereModulo = " AND tab1.id_modulo = '" . $request['id_modulo'] . "' ";
            }

            $orden = "'" . $request['orden'] . "'";

            $whereAccesoPadre = " and id_acceso_padre = '" . $request['id_acceso_padre'] . "' ";

            $whereAccesoHijo = " and id_acceso_hijo = '" . $request['id_acceso'] . "' ";

            $sql = <<<EOD

   DELETE FROM ca_acceso_acceso where 1=1 $whereAccesoPadre $whereAccesoHijo and orden = $orden
   
EOD;

            CN_TABLE::executeSQL($sql);

            
            $sql = <<<EOD

   SELECT * FROM ca_acceso_acceso where 1=1 $whereAccesoPadre AND orden > $orden 
   
EOD;

            $records = CN_TABLE::executeSQL($sql);
            
            if(count($records)>0)
            {
                
                foreach ($records as $value) {
                    
                    $id_acce_padre=$value["id_acceso_padre"];
                    $id_acce_hijo=$value["id_acceso_hijo"];
                    $ord=$value["orden"]-1;
                    
                    
                       $sql = <<<EOD

   UPDATE ca_acceso_acceso SET orden=$ord where 1=1 and id_acceso_padre=$id_acce_padre and id_acceso_hijo = $id_acce_hijo
   
EOD;

                CN_TABLE::executeSQL($sql);
                    
                }
                
                
                
                
            }
            
            
            
            
            
            
            // Solo regsitra log la primera vez de consulta
            if ($rowStart == 0) {
                //Operaciones: 1-CONSULTAR, 2-ACTUALIZAR, 3-ADICIONAR, 4-ELIMINAR, 5-ANULAR
                $id_ope_bd = 2;
                //obtener id maestro tabla
                $id_mae_bd = CN_TABLE::consultarIdTablaBD('ca_acceso_acceso');
                //registro de consulta en tabla de log- la observacion puede o no enviarse ($request, $id_ope_bd, $id_mae_bd, $observacion)
                $sql = CN_TABLE::registrarLog($request, $id_ope_bd, $id_mae_bd);
            }

            $this->status = 0;
            $this->list_data = $records;
            $this->logMessage("[ACCESOS_ACCESOS] Consulta Remove exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->mensajeError = "ERROR REMOVE!!!";
            $this->list_data = array();
            $this->logMessage("ERROR REMOVE!!!");
            $this->logMessage("Error: " . $e->getMessage());
        }
    }

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
